/*
Ingegneria Clinica
Fondamenti di Informatica
Esame del 23 Gennaio 2008
*/

#include<stdio.h>
#include<stdlib.h>

#define MAX_CONTRIBUENTI 100
#define MAX_AUTO 100

typedef struct
{
     char codiceFiscale[100];
     char nome[100];
     char cognome[100];
     char categoria[100];
     int reddito;   
} Contribuente;

typedef struct
{
     char codiceFiscale[100];
     char modello[100];
     char classe;
     char targa[100];
} Auto;

int CaricaDatiContribuenti(Contribuente *, char *);
int CaricaDatiAuto(Auto *, char *);
void SottoRedditoMinimo(Contribuente *, int , char *, int );
void AutoLusso(Contribuente *, int , Auto *, int );

int CaricaDatiContribuenti(Contribuente *ElencoContribuenti, char *nomefile)
{
    FILE *fp;
    int counter = 0;
    char parolaDaLeggere[100];
    if((fp = fopen(nomefile,"r")) == NULL)
    {
         return 0;
    }
    while (fscanf(fp, "%s", parolaDaLeggere) != EOF)
    {
         strcpy(ElencoContribuenti->codiceFiscale, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoContribuenti->nome, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoContribuenti->cognome, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoContribuenti->categoria, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         ElencoContribuenti->reddito = atoi(parolaDaLeggere);
         ElencoContribuenti++;
         counter++;       
    }
    fclose(fp);
    return counter;
}

int CaricaDatiAuto(Auto *ElencoAuto, char *nomefile)
{
    FILE *fp;
    int counter = 0;
    char parolaDaLeggere[100];
    if((fp = fopen(nomefile,"r")) == NULL)
    {
         return 0;
    }
    while (fscanf(fp, "%s", parolaDaLeggere) != EOF)
    {
         strcpy(ElencoAuto->codiceFiscale, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoAuto->modello, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         ElencoAuto->classe = parolaDaLeggere[0];
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoAuto->targa, parolaDaLeggere);
         ElencoAuto++;
         counter++;       
    }
    fclose(fp);
    return counter;
}

void SottoRedditoMinimo(Contribuente *ElencoContribuenti,
                                    int num_contribuenti,
                                    char *categoria,
                                    int reddito_minimo)
{
    int i;
    printf("\nCategoria: %s -- Reddito minimo: %d\n",
                       categoria, reddito_minimo);
    printf("============================================\n");

    for(i = 0; i < num_contribuenti; i++, ElencoContribuenti++)
    {
            if( (strcmp(ElencoContribuenti->categoria, categoria) == 0) &&
                (ElencoContribuenti->reddito < reddito_minimo) )            
            {
                printf("%s %s %s %s %d\n",
                           ElencoContribuenti->codiceFiscale,
                           ElencoContribuenti->nome,
                           ElencoContribuenti->cognome,
                           ElencoContribuenti->categoria,
                           ElencoContribuenti->reddito);
            }          
    }
    printf("\n");
}

void AutoLusso(Contribuente *ElencoContribuenti,
                                              int num_contribuenti,
                                              Auto *ElencoAuto,                                              
                                              int num_auto)
{
    int m,i,j;
    
    printf("\nContribuenti con auto di lusso \n"
           "=====================================================\n");
      

    for(m = 0; m <  num_auto; m++)
    {
          if (ElencoAuto[m].classe == 'A')
          for(i = 0; i < num_contribuenti; i++)
          {
                if( (strcmp(ElencoAuto[m].codiceFiscale,
                            ElencoContribuenti[i].codiceFiscale) == 0)  )
                
               {
                          printf("%s %s %s %s %d\n",
                                     ElencoContribuenti[i].codiceFiscale,
                                     ElencoContribuenti[i].nome,
                                     ElencoContribuenti[i].cognome,
                                     ElencoAuto[m].modello,
                                     ElencoContribuenti[i].reddito);
               }
                
          }      
          
    }
    printf("\n");
}

int main(){
    Contribuente ElencoContribuenti[MAX_CONTRIBUENTI];
    int totale_contribuenti =
        CaricaDatiContribuenti(ElencoContribuenti,"contribuenti.txt");
    if(totale_contribuenti == 0)
    {
        printf("nessun contribuente caricato\n");
        exit(-1);
    }
    else
    {
        printf("caricati %d contribuenti\n", totale_contribuenti);    
    }
    Auto ElencoAuto[MAX_AUTO];
    int totale_auto = CaricaDatiAuto(ElencoAuto, "auto.txt");
    if(totale_auto == 0)
    {
        printf("nessun contribuente caricato\n");
        exit(-1);
    }
    else
    {
        printf("caricate %d auto\n", totale_auto);    
    }
    
    SottoRedditoMinimo(ElencoContribuenti, totale_contribuenti, "meccanico", 50000);
    
    AutoLusso(ElencoContribuenti,
                                totale_contribuenti,
                                ElencoAuto,                                              
                                totale_auto);    
     system("PAUSE");
}
